# -*- coding: utf-8 -*-
"""
Created on Mon Aug 28 14:08:06 2017

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import range
from builtins import super
from builtins import str

import sys

from .ruling import ruling
from copy import copy

class ruleNegation(ruling):
    
    type = 'rule-negation'
    
    def __init__(self, rule, *args, **kwargs):
        super(ruleNegation, self).__init__()        
        self.rule = rule
        
    def __str__(self):
        if self.rule.type == 'rule':
            return '!'+self.rule.name
        return '!'+str(self.rule)
        
    def setPo(self):
        return

    def apply(self, form, random = True, backtrace = False, s = [], *args, **kwargs):
        if backtrace:
            return False
        f = form.duplicate()
        print()
        for i in s:
            print(i, end='')
        print(' --> Neg(', end='')
        sys.stdout.flush()
        if self.rule.apply(f, backtrace = backtrace, s = ['\t__Neg:('], random = random):
            print(')', end = '')
            return False
        print(')\n--Negation satisfied--', end='')
        return form
